(**************************************************************************)
(*  Mana : A kana(romaji)-kanji conversion engine using ChaSen algorithm.    *)
(*  Copyright (C) 2003, 2004, 2005  Yamagata Yoriyuki                     *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*  it under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation; either version 2 of the License, or (at  *)
(*  your option) any later version.                                       *)
(*                                                                        *)
(*  This program is distributed in the hope that it will be useful, but   *)
(*  WITHOUT ANY WARRANTY; without even the implied warranty of            *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *)
(*  General Public License for more details.                              *)
(**************************************************************************)

(* $Id: parse.mli 132 2005-08-07 18:05:59Z yori $ *)

(** ʸĹʸΰ֤EUCʸοɽ롣*)

(** ѡ̤Ǽ뷿 *)
type parse_obj

(** [parse string state pos len ] [state]ȯ[string]
[pos]Ĺ[len]ʬʸϤѡ롣*)
val parse : string -> state:int -> pos:int -> len:int -> parse_obj

(** [best_path parse_obj pos][parse_obj][pos]ˤΡɤΤʤ
ǺŬʥΡɤؤΥѥȺǽ֤ȥȤȤ֤ѥ[(mrph, p,
l, state, cost)]ΥꥹȤȤɽ졢[p]ʸΰ֡[l]б
ʬʸĹ[state][mrph]Ϣܤľξ֡[cost]
[mrph]ޤ᤿[mrph]ޤǤȡ*)
val best_path : parse_obj -> int -> 
  (Chasen.mrph * int * int * int * int) list

(** [list_candidates string state pos mrph_len len][state]ȯ
[string][pos]Ĺ[mrph_len]ʬʸбǤ󤹤롣
ͤϷ,Ǥб븶ʸĹ,ηǤ
ʸκŬȤ[(mrph, state, cost)]ΥꥹȤǤ롣*)
val list_candidates : string ->
  state:int -> pos:int -> mrph_len:int -> len:int -> 
  (Chasen.mrph * int * int) list


